import requests
import os
import time
start_time = time.time()
course_id = 1007316
#course_id = raw_input("Please Enter the Course ID")
token = "13~yzhFaj1P25Goq6BiY1nOoB9nCWjvEY4UEDciMMXAZLT0BT2WJTUpOBL9Xuqzk37L"
r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/' % course_id, headers = {'Authorization': 'Bearer ' + '%s' % token})
data = r.json()
course_name = data[u'name']

#Finds user's home directory
from os.path import expanduser
home = expanduser("~")

#Create a folder to store html files. 
path = "/%s/desktop/%s" % (home, course_name)
if not os.path.exists(path):
    os.mkdir(path, 0755)

#Retrieve all modules in a course
r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/modules/?per_page=100&page=1' % course_id, headers = {'Authorization': 'Bearer ' + '%s' % token})
data = r.json()
				
#Creates list of all modules id in a course
module = []
for d in data:
	module.append(d['id'])

#Being Loop for listing all items in a module
for id in module:
	module_id = id
	payload = {'include': 'items'}
	r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/modules/%s'% (course_id, module_id), params=payload, headers = {'Authorization': 'Bearer ' + '%s' % token})
	data = r.json()
	name = data['name']
	File = open('%s/%s.html' % (path, name) , 'w')
	File.write('<head><meta charset="UTF-8"></head>\n')	
	File.write('<h1><center>%s</center></h1>' % name)
	#open = data['unlock_at']
	#if open == None:
	#	pass
	#if open > current:
	#	File.write('<h2><center>%s is not open yet.</center></h2>' % name)


		
#List items in a module
	for d in data['items']:
		if d['type'] == "Page":
			page_url = d['page_url']
			r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/pages/%s' % (course_id, page_url), headers = {'Authorization': 'Bearer ' + '%s' % token})
			pagedata = r.json()
			pagecontents = pagedata[u'body'].encode('utf-8')
			pagename= pagedata[u'title'].encode('utf-8')
			if pagedata[u'body'] != '':
				File = open('%s/%s.html' % (path, name) , 'a')
				File.write('<head><meta charset="UTF-8"></head>\n')
				File.write('<h2><center>%s</center></h2>' % pagename)
				File.write("%s" % pagecontents)	
			else:
				File.write('<h2><center>%s</center></h2>' % pagename)
				File.write('<center>This page is not available for printing</center>')
#Retrieving body of Assignment items and writing to file
	for d in data['items']:
		if d['type'] == "Assignment":
			assignment_id = d['content_id']
			r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/assignments/%s' % (course_id, assignment_id), headers = {'Authorization': 'Bearer ' + '%s' % token})
			assigndata = r.json()
			assigncontents = assigndata[u'description'].encode('utf-8')
			assignname = assigndata[u'name'].encode('utf-8')
			if assigndata[u'description'] != '':
				File = open('%s/%s.html' % (path, name) , 'a')
				File.write('<head><meta charset="UTF-8"></head>\n')
				File.write('<h2><center>%s</center></h2>' % assignname)
				File.write("%s" % assigncontents)
			else: 
				File.write('<h2><center>%s</center></h2>' % assignname)
				File.write('<center>This assignment is not available for printing.</center>')
	for d in data['items']:
		if d['type'] == "Discussion":
			discuss_id = d['content_id']
			r = requests.get('https://webcourses.ucf.edu/api/v1' + '/courses/%s/discussion_topics/%s' % (course_id, discuss_id), headers = {'Authorization': 'Bearer ' + '%s' % token})
			discussdata = r.json()	
			discusscontents = discussdata[u'message'].encode('utf-8')
			discussname = discussdata[u'title'].encode('utf-8')
			if discussdata[u'message'] != '':
				discusscontents = discussdata[u'message'].encode('utf-8')
				discussname = discussdata[u'title'].encode('utf-8')
				File = open('%s/%s.html' % (path, name) , 'a')
				File.write('<head><meta charset="UTF-8"></head>\n')
				File.write('<h2><center>%s</center></h2>' % discussname)
				File.write("%s" % discusscontents)
			else:
				File.write('<h2><center>%s</center></h2>' % discussname)
				File.write('<center>This discussion is not available for printing.</center>')
File.close()
done = time.time() - start_time
if done > 60:
	new_done = done / 60
	print "This request took " + str(new_done) + " minutes"
else: 	
	print "This request took " + str(done) + " seconds"
